import { VueApolloSubscriptionDefinition } from 'vue-apollo/types/options';
import { ApolloError, OperationVariables } from 'apollo-client';
import { DocumentNode } from 'graphql';
import { Vue } from 'vue/types/vue';
import { ApolloOperationErrorHandlerFunction } from './types';
export declare type VueApolloSmartSubscriptionErrorHandler<TResult = any, TVariables = OperationVariables, TError = ApolloError, TApp extends Vue = Vue> = (error: TError, vm: TApp, key: string, type: 'subscription', options: VueApolloSmartSubscriptionOptions<TResult, TVariables, TError, TApp>) => void;
export declare type VueApolloSmartSubscriptionOptions<TResult = any, TVariables = OperationVariables, TError = ApolloError, TApp extends Vue = Vue> = Omit<VueApolloSubscriptionDefinition<TVariables>, 'error'> & {
    error?: VueApolloSmartSubscriptionErrorHandler<TResult, TVariables, TError, TApp>;
};
export declare function createSmartSubscriptionOptionsFunction<TResult, TVariables, TError = ApolloError, TApp extends Vue = Vue>(query: DocumentNode, onError?: ApolloOperationErrorHandlerFunction<TError, TApp>): (options?: Partial<VueApolloSmartSubscriptionOptions<TResult, TVariables, TError, TApp>>) => VueApolloSubscriptionDefinition<TVariables>;
